MWAWTable Class Reference

a class used to recreate the table structure using cell informations, .... More...

`#include <MWAWTable.hxx>`

Inheritance diagram for MWAWTable:

## Public Types

enum | DataSet { CellPositionBit =1, BoxBit =2, SizeBit =4, TableDimBit =8, TablePosToCellBit =0x10 }
| an enum used to indicate what the list of entries which are filled More...
enum | Alignment { Paragraph, Left, Center, Right }
| an enum do define the table alignement. More...

## Public Member Functions

| MWAWTable (uint32_t givenData=BoxBit)
| the constructor More...
virtual | ~MWAWTable ()
| the destructor More...
void | add (shared_ptr< MWAWCell > cell)
| add a new cells More...
bool | mergeBorders () const
| returns true if we need to merge borders More...
bool | setMergeBorders (bool val)
| sets the merge borders' value More...
void | setAlignment (Alignment align, float leftMargin=0, float rightMargin=0)
| defines the current alignment More...
int | numCells () const
| returns the number of cell More...
std::vector< float > const & | getRowsSize () const
| returns the row size if defined (in point) More...
void | setRowsSize (std::vector< float > const &rSize)
| define the row size (in point) More...
std::vector< float > const & | getColsSize () const
| returns the columns size if defined (in point) More...
void | setColsSize (std::vector< float > const &cSize)
| define the columns size (in point) More...
shared_ptr< MWAWCell > | get (int id)
| returns the i^th cell More...
bool | updateTable ()
| try to build the table structures More...
bool | hasExtraLines ()
| returns true if the table has extralines More...
bool | sendTable (MWAWContentListenerPtr listener, bool inFrame=true)
| try to send the table More...
bool | sendAsText (MWAWContentListenerPtr listener)
| try to send the table as basic text More...
void | addTablePropertiesTo (WPXPropertyList &propList, WPXPropertyListVector &columns) const
| adds the table properties to propList More...

## Protected Member Functions

int | getCellIdPos (int col, int row) const
| convert a cell position in a posToCellId's position More...
bool | buildStructures ()
| create the correspondance list, ... More...
bool | buildDims ()
| compute the rows and the cells size More...
bool | buildPosToCellId ()
| a function which fills to posToCellId vector using the cell position More...
void | sendExtraLines (MWAWContentListenerPtr listener) const
| send extra line More...

## Protected Attributes

uint32_t | m_givenData
| a int to indicate what data are given in entries More...
uint32_t | m_setData
| a int to indicate what data are been reconstruct More...
bool | m_mergeBorders
| do we need to merge cell borders ( default yes) More...
std::vector< shared_ptr < MWAWCell > > | m_cellsList
| the list of cells More...
size_t | m_numRows
| the number of rows ( set by buildPosToCellId ) More...
size_t | m_numCols
| the number of cols ( set by buildPosToCellId ) More...
std::vector< float > | m_rowsSize
| the final row size (in point) More...
std::vector< float > | m_colsSize
| the final col size (in point) More...
Alignment | m_alignment
| the table alignment More...
float | m_leftMargin
| the left margin in point More...
float | m_rightMargin
| the right margin in point More...
std::vector< int > | m_posToCellId
| a vector used to store an id corresponding to each cell More...
bool | m_hasExtraLines
| true if we need to send extra lines More...

## Detailed Description

a class used to recreate the table structure using cell informations, ....

## Member Enumeration Documentation

enum MWAWTable::Alignment

an enum do define the table alignement.

Note
  Paragraph means using the default alignment, left page alignment and use left margin

Enumerator
Paragraph |
Left |
Center |
Right |

enum MWAWTable::DataSet

an enum used to indicate what the list of entries which are filled

Enumerator
CellPositionBit |
BoxBit |
SizeBit |
TableDimBit |
TablePosToCellBit |

## Constructor & Destructor Documentation

MWAWTable::MWAWTable | ( | uint32_t | givenData = `BoxBit` | ) |

inline

the constructor

MWAWTable::~MWAWTable | ( |  | ) |

virtual

the destructor

## Member Function Documentation

void MWAWTable::add | ( | shared_ptr< MWAWCell > | cell | ) |

inline

add a new cells

Referenced by CWTable::readTableCells().

void MWAWTable::addTablePropertiesTo | ( | WPXPropertyList & | propList,
|  | WPXPropertyListVector & | columns
| ) |  | const

adds the table properties to propList

Referenced by MWAWContentListener::openTable().

bool MWAWTable::buildDims | ( |  | ) |

protected

compute the rows and the cells size

Referenced by updateTable().

bool MWAWTable::buildPosToCellId | ( |  | ) |

protected

a function which fills to posToCellId vector using the cell position

Referenced by updateTable().

bool MWAWTable::buildStructures | ( |  | ) |

protected

create the correspondance list, ...

Referenced by updateTable().

shared_ptr< MWAWCell > MWAWTable::get | ( | int | id | ) |

returns the i^th cell

Referenced by CWTableInternal::Table::get(), MWProStructuresInternal::Table::get(), HMWKGraphInternal::Table::get(), and WNTextInternal::Table::get().

int MWAWTable::getCellIdPos | ( | int | col,
|  | int | row
| ) |  | const

inline protected

convert a cell position in a posToCellId's position

Referenced by buildDims(), buildPosToCellId(), and sendTable().

std::vector<float> const& MWAWTable::getColsSize | ( |  | ) | const

inline

returns the columns size if defined (in point)

Referenced by MSWText::sendTable().

std::vector<float> const& MWAWTable::getRowsSize | ( |  | ) | const

inline

returns the row size if defined (in point)

bool MWAWTable::hasExtraLines | ( |  | ) |

inline

returns true if the table has extralines

Referenced by HMWJGraph::sendFrame(), and HMWKGraph::sendFrame().

bool MWAWTable::mergeBorders | ( |  | ) | const

inline

returns true if we need to merge borders

Referenced by addTablePropertiesTo().

int MWAWTable::numCells | ( |  | ) | const

inline

returns the number of cell

Referenced by CWTableInternal::Table::get(), MWProStructuresInternal::Table::get(), WNTextInternal::Table::get(), HMWKGraph::getTextFrameInformations(), CWTable::readTableBordersId(), CWTable::readTablePointers(), CWTableInternal::Table::updateCells(), and HMWJGraphInternal::Table::updateCells().

bool MWAWTable::sendAsText | ( | MWAWContentListenerPtr | listener | ) |

try to send the table as basic text

Referenced by HMWJGraph::sendFrame(), HMWKGraph::sendFrame(), HMWJGraph::sendTableUnformatted(), and HMWKGraph::sendTableUnformatted().

void MWAWTable::sendExtraLines | ( | MWAWContentListenerPtr | listener | ) | const

protected

send extra line

Referenced by sendTable().

bool MWAWTable::sendTable | ( | MWAWContentListenerPtr | listener,
|  | bool | inFrame = `true`
| ) |  |

try to send the table

Note: either send the table ( and returns true ) or do nothing.

Referenced by HMWJGraph::sendFrame(), and HMWKGraph::sendFrame().

void MWAWTable::setAlignment | ( | Alignment | align,
|  | float | leftMargin = `0`,
|  | float | rightMargin = `0`
| ) |  |

inline

defines the current alignment

Note
  : leftMargin,rightMargin are given in Points

Referenced by WPParser::readTable().

void MWAWTable::setColsSize | ( | std::vector< float > const & | cSize | ) |

inline

define the columns size (in point)

Referenced by MSWText::prepareTables(), WPParser::readTable(), MRWText::sendTable(), FWText::sendTable(), and MSKGraph::sendTable().

bool MWAWTable::setMergeBorders | ( | bool | val | ) |

inline

sets the merge borders' value

Referenced by MRWText::sendTable().

void MWAWTable::setRowsSize | ( | std::vector< float > const & | rSize | ) |

inline

define the row size (in point)

bool MWAWTable::updateTable | ( |  | ) |

try to build the table structures

Referenced by hasExtraLines(), HMWJGraph::sendFrame(), HMWKGraph::sendFrame(), and sendTable().

## Member Data Documentation

Alignment MWAWTable::m_alignment

protected

the table alignment

Referenced by addTablePropertiesTo(), and setAlignment().

std::vector<shared_ptr<MWAWCell> > MWAWTable::m_cellsList

protected

the list of cells

Referenced by add(), buildDims(), buildPosToCellId(), buildStructures(), CWTableInternal::Table::checkChildZones(), get(), numCells(), sendAsText(), sendExtraLines(), and sendTable().

std::vector<float> MWAWTable::m_colsSize

protected

the final col size (in point)

Referenced by addTablePropertiesTo(), buildDims(), buildPosToCellId(), buildStructures(), getColsSize(), sendExtraLines(), and setColsSize().

uint32_t MWAWTable::m_givenData

protected

a int to indicate what data are given in entries

Referenced by updateTable().

bool MWAWTable::m_hasExtraLines

protected

true if we need to send extra lines

Referenced by buildPosToCellId(), hasExtraLines(), and sendTable().

float MWAWTable::m_leftMargin

protected

the left margin in point

Referenced by addTablePropertiesTo(), and setAlignment().

bool MWAWTable::m_mergeBorders

protected

do we need to merge cell borders ( default yes)

Referenced by mergeBorders(), and setMergeBorders().

size_t MWAWTable::m_numCols

protected

the number of cols ( set by buildPosToCellId )

Referenced by buildDims(), buildPosToCellId(), getCellIdPos(), sendTable(), and updateTable().

size_t MWAWTable::m_numRows

protected

the number of rows ( set by buildPosToCellId )

Referenced by buildDims(), buildPosToCellId(), getCellIdPos(), sendTable(), and updateTable().

std::vector<int> MWAWTable::m_posToCellId

protected

a vector used to store an id corresponding to each cell

Referenced by buildDims(), buildPosToCellId(), and sendTable().

float MWAWTable::m_rightMargin

protected

the right margin in point

Referenced by addTablePropertiesTo(), and setAlignment().

std::vector<float> MWAWTable::m_rowsSize

protected

the final row size (in point)

Referenced by buildDims(), buildPosToCellId(), buildStructures(), getRowsSize(), sendExtraLines(), sendTable(), and setRowsSize().

uint32_t MWAWTable::m_setData

protected

a int to indicate what data are been reconstruct

Referenced by buildDims(), buildPosToCellId(), buildStructures(), and updateTable().

The documentation for this class was generated from the following files:

- MWAWTable.hxx
- MWAWTable.cxx